1; # cardinali.pm
package cardinali;

%cifre=(0,"", 1,"uno", 2,"due", 3,"tre",
  4,"quattro", 5,"cinque", 6,"sei", 7,"sette",
  8,"otto", 9,"nove");
%decine=(2,"venti", 3,"trenta",
  4,"quaranta", 5,"cinquanta", 6,"sessanta",
  7,"settanta", 8,"ottanta", 9,"novanta");
%dadiecia19=(10,"dieci", 11,"undici",
  12,"dodici", 13,"tredici", 14,"quattordici",
  15,"quindici", 16,"sedici", 17,"diciasette",
  18,"diciotto", 19,"diciannove");

sub centinaia {my $n=shift; my $a;
  return decine($n) if $n<100;
  $cent=int($n/100); $cent==1 ? $a="" :
  $a=$cifre{$cent};
  $a."cento".decine($n%100)}

sub decine {my $n=shift; my ($a,$b);
  return $cifre{$n} if $n<10;
  return $dadiecia19{$n} if $n<20;
  $a=$decine{int($n/10)};
  $b=$cifre{$n%10};
  chop $a if $b=~/^[uo]/; "$a$b"}

sub migliaia {my $n=shift; $n==0 ? "" :
  $n==1 ? "mille" : centinaia($n)."mila"}

sub milioni {my $n=shift; $n==0 ? "" :
  $n==1 ? "unmilione" :
  centinaia($n)."milioni"}

sub parola {my $n=shift;
  return "zero" if $n==0;
  my ($mili,$migl,$cent)=parti($n);
  milioni($mili)."\n".migliaia($migl).
  "\n".centinaia($cent)}

sub parti {my $n=shift;
  my ($mili,$migl,$cent);
  $mili=int($n/1000000);
  $migl=int(($n%1000000)/1000);
  $cent=$n%1000; ($mili,$migl,$cent)}
